<?php
Class lwliad_AD_Config{
    public static function  lwliad_AD_setup(){
        $url = get_option('lwliad_AD_Config_ldapURl');
        $port =get_option('lwliad_AD_Config_ldapport');

        $urltofeed = $url.':'.$port;

        $con = ldap_connect($urltofeed);
   

        if($con){
            $dn =get_option('lwliad_AD_Config_ldapDn');
            $password =get_option('lwliad_AD_Config_ldappassword');
           
            ldap_set_option($con, LDAP_OPT_PROTOCOL_VERSION, 3);
            ldap_set_option($con, LDAP_OPT_REFERRALS, 0);

            $bind = ldap_bind( $con, $dn, $password);

            

            if($bind){
                return $con;
            }else{
                return array('Error'=>"Error trying to bind: ".ldap_error($con));
            }
            
        }
        else{
            
            return array('Error'=>"That LDAP-URI was not parseable");
        }

       
        
        
    } 
    /** fetching search base */
    function lwliad_searchBase(){
        $con = self::lwliad_AD_setup();
        if($con){
            $result = ldap_read($con, '', '(objectclass=*)', array('namingContexts'));
            $data = ldap_get_entries($con, $result);
            return $data[0]['namingcontexts'][0] ;
        }

        

    }

    function lwliad_authenticate($username, $password){

        $con = self::lwliad_AD_setup();
        if($con){
          
            $filter = get_option('lwliad_AD_Config_ldapFilter');
            $filter =str_replace('?',$username, $filter);
            $searchBase = Self::lwliad_searchBase();
            $result = ldap_search($con, $searchBase, $filter );
            $data = ldap_get_entries($con, $result);
 
            if($data['count'] >0){
                          
                $user_dn = $data[0]['dn'];                   
 
                $bind = ldap_bind( $con, $user_dn, $password);  
                
       

                if($bind){
                    return true;
                }
                else{
                    
                return array('Error' => ldap_error($con));
                }
            }
           
        }



    }

    /* Test LDAP Config  */

    function testConfig($username, $password){

        $con = self::lwliad_AD_setup();
        if($con){
            $filter = get_option('lwliad_AD_Config_ldapFilter');
            $filter =str_replace('?',$username, $filter);
            $searchBase = Self::lwliad_searchBase();
            $result = ldap_search($con, $searchBase, $filter );
            $data = ldap_get_entries($con, $result);

      
           
            if($data['count'] > 0){
              
                return array('Success'=>"User Exist.");

            }else{
                
                return array('Error'=>"Please Enter valid credentials.");
            }

           
            
        }
       
     

    }
    /* fetch attributes of users from AD */

    function fetch_attributes_for_username($username){
        $con = self::lwliad_AD_setup();
        if($con){
            $filter = get_option('lwliad_AD_Config_ldapFilter');
            $filter =str_replace('?',$username, $filter);
            $searchBase = Self::lwliad_searchBase();
            $result = ldap_search($con, $searchBase, $filter );
            $data = ldap_get_entries($con, $result);
            
            return $data;

        }

    }


    /** Fetch user details and mapped roles */

    function fetch_roles_for_username($username){


        $con = self::lwliad_AD_setup();
        if($con){
            $filter = get_option('lwliad_AD_Config_ldapFilter');
            $filter =str_replace('?',$username, $filter);
            $attrib = array('memberOf');
            $searchBase = Self::lwliad_searchBase();
            
            $result = ldap_search($con, $searchBase, $filter, $attrib );
            $data = ldap_get_entries($con, $result);

            


            $role = array();
            if(isset($data[0]['memberof'])){
                if(in_array(get_option('lwliad_AD_roleAgainstAdmin'),$data[0]['memberof'])){
                    $role[]="administrator";
                }
                if(in_array(get_option('lwliad_AD_roleAgainstSubscriber'),$data[0]['memberof'])){
                        $role[]="subscriber";

                }
                if(in_array(get_option('lwliad_AD_roleAgainstEditor'),$data[0]['memberof'])){
                        $role[]="editor";

                }
                if(in_array(get_option('lwliad_AD_roleAgainstContributer'),$data[0]['memberof'])){

                            $role[]="contributor";
                }
            }
            
            return $role;
          

        }

    }



/** Mapping AD roles to WP users */
    function set_users_role($user_id, $username){

        $roles = self::fetch_roles_for_username($username);
        $newuser = new WP_User($user_id);
        $newuser->set_role('');

        
        if(sizeof($roles)>0){
           
            foreach($roles as $role){
                $newuser->add_role($role);
            }    
  
        }
        else{     
            
            $newuser->set_role('');           
            $newuser->add_role(get_option('lwliad_deaultRole'));
        }

 

    }
    


}