<?php
function lwliad_ladp_auth_layout()
{
    isset($_GET['tab']) ? $active_tab = $_GET['tab'] : $active_tab = 'ldapConfig';
?>

<style>
    .card{
        max-width:633px;
    }

    tr td {
        padding: 12px 5px 0px 0px;
    }
    tr td:first-child {
        max-width:8rem;
        min-width:6rem;
    }
    </style>


    <div class="wrap">

        <h2>LDAP AD Intergration</h2>

        <h2 class="nav-tab-wrapper" style="border:none;">
            <a href="<?php echo add_query_arg(array('tab' => 'ldapConfig'), $_SERVER['REQUEST_URI']); ?>" class="nav-tab <?php echo $active_tab == 'ldapConfig' ? 'nav-tab-active' : ''; ?>" style="border-bottom:1px solid #ccc;">LDAP Configuration</a>
            <a href="<?php echo add_query_arg(array('tab' => 'loginSetup'), $_SERVER['REQUEST_URI']); ?>" class="nav-tab <?php echo $active_tab == 'loginSetup' ? 'nav-tab-active' : ''; ?>" style="border-bottom:1px solid #ccc;">LDAP Login Set up</a>
            <a href="<?php echo add_query_arg(array('tab' => 'attributeMapping'), $_SERVER['REQUEST_URI']); ?>" class="nav-tab <?php echo $active_tab == 'attributeMapping' ? 'nav-tab-active' : ''; ?>" style="border-bottom:1px solid #ccc;">Attribute Mapping</a>
            <a href="<?php echo add_query_arg(array('tab' => 'roleMapping'), $_SERVER['REQUEST_URI']); ?>" class="nav-tab <?php echo $active_tab == 'roleMapping' ? 'nav-tab-active' : ''; ?>" style="border-bottom:1px solid #ccc;">Role Mapping</a>
            <a href="<?php echo add_query_arg(array('tab' => 'help'), $_SERVER['REQUEST_URI']); ?>" class="nav-tab <?php echo $active_tab == 'help' ? 'nav-tab-active' : ''; ?>" style="border-bottom:1px solid #ccc;">Help</a>
        </h2>

    </div>

    
        <!--better CSS purpose like container -->


        <?php
        if ($active_tab === 'ldapConfig') ldapconfig();
        else  if ($active_tab === 'loginSetup') loginsetup();
        else  if ($active_tab === 'attributeMapping') attributemapping();
        else  if ($active_tab === 'roleMapping') rolemapping();
        else  if ($active_tab === 'help') help();

        ?>

    <?php }
function ldapconfig()
{
    ?>

        <div class="card">
            <div>
                <h3> Configuration to integrate AD </h3>
                <form id="ldapConfig" method="post" action="">
                    <input type="hidden" name="action" value="ldapConfig" />
                    <?php wp_nonce_field('ldapConfig_nonce','ldapConfig_nonce') ?>
                    <table>
                        <tr >
                            <td >Ldap URI</td>
                               <td><input type="text" id="ldapURI" style="width:15rem;" name="ldapURI" placeholder="ldap://example.com" value="<?php echo esc_attr(get_option('lwliad_AD_Config_ldapURl')); ?>"/>
                                <input type="text" id="ldapport" name="ldapport" style="width:3rem;" value="<?php if(get_option('lwliad_AD_Config_ldapport'))echo esc_attr(get_option('lwliad_AD_Config_ldapport')); else echo esc_attr('389'); ?>"/>
                                <p style="margin:0px;font-style:italic;font-size:10px;">eg: ldap://www.example.com or ldap://15.25.421.25</p>
                                </td>
                        </tr>
                        <tr>
                            <td>Ldap DN</td>
                            <td> <input type="text" id="ldapDN" name="ldapDN"  style="width:15rem;"placeholder="user1@example.com" value="<?php if(get_option('lwliad_AD_Config_ldapDn')) echo esc_attr(get_option('lwliad_AD_Config_ldapDn')); ?>" />
                                <p style="margin:0px;font-style:italic;font-size:10px;">eg: user1@example.com or CN=user1,CN=Users,DC=example,DC=com</p>
                            </td>
                        </tr>
                        <tr >
                            <td>Ldap password</td>
                            <td><input type="password" id="ldappassword" name="ldappassword" style="width:15rem;"placeholder="password" value="<?php echo esc_attr(get_option('lwliad_AD_Config_ldappassword'));?>" /></td>

                        </tr>

                        <tr>
                            <td>Filter</td>
                            <td><select id ="ldapFilter" name="ldapFilter" style="width:15rem;" >
                                    <option value="none">Select the Username Attribute</option>
                                    <option value="sAMAccountName" <?php if (get_option('lwliad_AD_Config_filter') == 'sAMAccountName') echo esc_attr('selected'); ?>>sAMAccountName</option>
                                    <option value="userPrincipalName" <?php if (get_option('lwliad_AD_Config_filter') == 'userPrincipalName') echo esc_attr('selected'); ?>>userPrincipalName</option>
     
                                </select></td>
                        </tr>

                        <tr>

                            <td colspan="2" style="padding-left: 8rem; padding-top:1rem;"><input type="submit" id="ADconfig" value="Save" /></td>
                        </tr>
                    </table>
                </form>
            </div>


            <div style="margin-top:3rem;">
                <h3> Test Configuration</h3>
                <form id="testLDAPConfig" method="post" action="">
                    <input type="hidden" name="action" value="testLdapConfig" />
                    <?php wp_nonce_field('testldapConfig_nonce','testldapConfig_nonce') ?>
                    <table>
                        <tr>
                            <td> <label>username</label></td>
                            <td> <input type="text" id="username" name="username" require  /></td>
                        </tr>
                        <tr>
                            <td>password</td>
                            <td> <input type="password" id="password" name="password" require /></td>
                        </tr>
                        <tr>
                            <td colspan="2" style="padding-left: 8rem; padding-top:1rem;"> <input type="submit" id="ADconfig" value="Test" /></td>
                        </tr>
                    </table>
                </form>
            </div>

        </div>

    <?php

}
function loginsetup()
{
    ?>

        <div class="card">
            
                <h3> Configuration for WordPress Login</h3>
                <form id="loginsettings" method="POST" action="">
                    <input type="hidden" name="action" value="ldapsettings" />
                    <?php wp_nonce_field('ldapsettings_nonce','ldapsettings_nonce') ?>
                    <div style="margin:1rem;">
                        <input type="checkbox" id="ldapLogin" name="ldapLogin" <?php if(get_option('lwliad_AD_ldapLogin') == '1') echo esc_attr('checked');?>  >By enabling this option user will login using the AD(Active Direcrory) credentials.

                    </div>
                    <div style="margin:1rem;">
                        <input type="checkbox" id="disableWPLogin" name="disableWPLogin" <?php if(get_option('lwliad_AD_ldapLogin') == '0') echo esc_attr('disabled');?>  <?php if(get_option('lwliad_disableWPLogin') == 1) echo 'checked';?>  >By enabling this user can't login with the WordPress credentials.
                    </div>
                    <div style="padding-left: 4rem;"><input class="btn btn-primary" type="submit" value="Save" />
            
                </form>
            
        </div>

        <script>
            jQuery('#ldapLogin').click(function(){
                if(jQuery('#ldapLogin').prop("checked") == true){
                    jQuery('#disableWPLogin').attr("disabled",false);
                }else{
                    jQuery('#disableWPLogin').attr("disabled",true);
                }
            });
        </script>

    <?php

}
function attributemapping()
{
    ?>

        <div class="card">

            <div>
                <h3> Get Attributes</h3>
                <form id="attributemapping" method="POST" action="">
                    <input type="hidden" name="action" value="testattributeMappingSettings" />
                    <?php wp_nonce_field('testattributeMappingSettings_nonce','testattributeMappingSettings_nonce') ?>
                    <table>
                        <tr>
                            <td colspan="2" style="width:100%; padding:0px;">
                                <p> You can obtain the attributes available to the user to configure attribute mapping by entering the username(depending on the filter) of the user.</p>
                            </td>
                        </tr>
                        <tr>
                            <td style="width:23%;"><label>username</td>
                            <td><input type="input" id="ldapUsername" name="ldapUsername" disabled/></td>
                        </tr>

                        <tr>
                            <td colspan="2" style="padding-left: 5rem; padding-top:1rem;"> <input type="submit" id="getattributes" value="Check Attributes" disabled /></td>
                        </tr>
                    </table>
                </form>
            </div>
            <div style="margin-top:3rem;">
                <h3> Map WP attributes to AD attributes</h3>
                <form method="POST" action="">
                    <input type="hidden" name="action" value="attributeMappingSettings" />
                    <?php wp_nonce_field('attributeMappingSettings_nonce','attributeMappingSettings_nonce') ?>
                    <table>
                        <tr >
                            <td>Email</td>
                            <td> <input type="text" id="ldapemail" name="ldapemail"  value="<?php echo esc_attr(get_option('lwliad_AD_attr_map_email'));?>"  /></td>
                        </tr>
                        <tr>
                            <td>FirstName</td>
                            <td> <input type="text" id="ldapFirstName" name="ldapFirstName"  value="<?php echo esc_attr(get_option('lwliad_AD_attr_map_firstName'));?>"/></td>
                        </tr>
                        <tr>
                            <td>Lastname</td>
                            <td> <input type="text" id="ldapLastName" name="ldapLastName" value="<?php echo esc_attr(get_option('lwliad_AD_attr_map_lastName'));?>"/></td>

                        </tr>


                        <tr>
                            <td colspan="2" style="padding-left: 5rem; padding-top:1rem;"> <input type="submit" id="ADconfig" value="Save" /></td>
                        </tr>
                    </table>
                </form>
            </div>


        </div>

     

    <?php
}
function rolemapping()
{
    ?>


        <div class="card">

            <div >
                <h3> Get Roles</h3>

                <form id="testgroups" method="POST" action="">
                    <table>
                        <tr>
                            <td colspan="2" style="width:100%; padding:0px;">
                                <p> By entering the memberof you can receive the groups available for the user to configure Role Mapping. </p>
                            </td>
                        </tr>
                        <tr>
                            <td style="width:23%;"><label>Group ID</label></td>
                             <td><input type="input" id="ldapgroup"  disabled value="memberof"/></td>
                        </tr>

                        <tr>
                            <td colspan="2" style="padding-left: 5rem; padding-top:1rem;"> <input type="button" id="getgroups" disabled value="Test" /></td>
                        </tr>
                    </table>
                </form>




            </div>

            <div>
            <div>
            <form id="groups" method="POST" action="">
                    <input type="hidden" name="action" value="groupMappingSettings" />
                    <?php wp_nonce_field('groupMappingSettings_nonce','groupMappingSettings_nonce') ?>
                    <h3> Role Mapping </h3>
                    <div style="margin:1rem;">
                    <input type="checkbox" id="enabledefaultRole" name="enabledefaultRole" <?php if(get_option('lwliad_enabledefaultRole') == 1) echo esc_attr('checked') ; ?>  > Enabling Role Mapping 
                    <p style="font-style:italic;font-size:13px;">Role Mapping automatically maps users from LDAP groups to the default WordPress role selected below on user login with AD credentials.</p>
                
                    </div>
      
               
        

            <div>               
                 <table>
                    <tr>
                        <td>Default Role:</td>
                        <td>  
                            <select id="deaultRole" name="deaultRole" >
                                    <option value="none">Select Default user role</option>
                                    <option value="subscriber" <?php if (get_option('lwliad_deaultRole') == 'subscriber') echo esc_attr('selected'); ?>>Subscriber</option>
                                    <option value="editor" <?php if (get_option('lwliad_deaultRole') == 'editor') echo esc_attr('selected'); ?>>Editor</option>
                                    <option value="contributor" <?php if (get_option('lwliad_deaultRole') == 'contributor') echo esc_attr('selected'); ?>>Contributor</option>
                                    <option value="administrator" <?php if (get_option('lwliad_deaultRole') == 'administrator') echo esc_attr('selected'); ?>>Administrator</option>
                            </select>
                        </td>
                    </tr>
               
                    <tr>
                        <td>Administrator:</td>
                        <td><input type="text" id="roleAgainstAdmin" name="roleAgainstAdmin" placeholder="CN=prefix,DC=domain,DC=com" style="width:20rem;" value="<?php echo esc_attr(get_option('lwliad_AD_roleAgainstAdmin'));?>">
                             <p style="margin:0px;font-style:italic;font-size:9px;">eg: CN=GroupA,CN=Users,DC=example,DC=com</p>
                        </td>
                    </tr>
                    <tr>
                        <td>Editor:</td>
                        <td><input type="text" id="roleAgainstEditor" name="roleAgainstEditor" placeholder="CN=prefix,DC=domain,DC=com" style="width:20rem;" value="<?php echo esc_attr(get_option('lwliad_AD_roleAgainstEditor'));?>">
                        <p style="margin:0px;font-style:italic;font-size:9px;">eg: CN=GroupA,CN=Users,DC=example,DC=com</p>
                        </td>
                    </tr>
                    <tr>
                        <td>Contributer:</td>
                        <td><input type="text" id="roleAgainstContributer" name="roleAgainstContributer" placeholder="CN=prefix,DC=domain,DC=com"  style="width:20rem;" value="<?php echo esc_attr(get_option('lwliad_AD_roleAgainstContributer'));?>">
                        <p style="margin:0px;font-style:italic;font-size:9px;">eg: CN=GroupA,CN=Users,DC=example,DC=com</p>    
                        </td>
                    </tr>
                    <tr>
                        <td>Subscriber:</td>
                        <td><input type="text" id="roleAgainstSubscriber" name="roleAgainstSubscriber" style="width:20rem;" value="<?php echo esc_attr(get_option('lwliad_AD_roleAgainstSubscriber'));?>">
                        <p style="margin:0px;font-style:italic;font-size:9px;">eg: CN=GroupA,CN=Users,DC=example,DC=com</p>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="=2" style="padding-left: 5rem; padding-top:1rem;"><input type="submit" value="Save"></td>
                    </tr>
                        
                    
                    
                </table>
            </div>



            </div>
        </div>
</form>
<script>
            jQuery('#ldapLogin').click(function(){
                if(jQuery('#ldapLogin').prop("checked") == true){
                    jQuery('#disableWPLogin').attr("disabled",false);
                }else{
                    jQuery('#disableWPLogin').attr("disabled",true);
                }
            });
        </script>
    <?php
}
function help()
{
    ?>
		<div class="card">
            <div>

			<p>For support or troubleshooting help please email us at <a href="mailto:ldapsso@protonmail.com">ldapsso@protonmail.com</a>.</p>
			</div>
		</div>

    <?php

} 